require_relative 'spec_helper'
require 'studio_game/player'
require 'studio_game/berserk_player'

module StudioGame
	describe BerserkPlayer  do 
		
		before do
			@inital_health = 50 
			@berserk_player = BerserkPlayer.new('berserker', @inital_health)
		end

		it "does not go berserk when w00ted up to 5 times" do
			1.upto(5) {@berserk_player.w00t}
			@berserk_player.berserk?.should be_falsey
		end

		it "goes berserk when w00ted more then 5 times" do
			1.upto(6) {@berserk_player.w00t}
			@berserk_player.berserk?.should be_truthy
		end

		it "get's w00ted instead of blammed when it's gone berserk" do
			1.upto(6) {@berserk_player.w00t}
			1.upto(2) {@berserk_player.blam}

			@berserk_player.health.should == @inital_health + (8 * 15)
		end
	end
end
