require_relative 'spec_helper'
require 'studio_game/player'
require 'studio_game/clumsy_player'

module StudioGame
	describe ClumsyPlayer do
		before do
			@player = ClumsyPlayer.new("Klutz")
		end

		it "only get's half the point value for each treasure" do 
			@player.points.should == 0

			hammer = Treasure.new(:hammer, 50)
			@player.found_treasure(hammer)
			@player.found_treasure(hammer)
			@player.found_treasure(hammer)

			@player.points.should == 75

			crowbar = Treasure.new(:crowbar, 400)
	    	@player.found_treasure(crowbar)
	    
	    	@player.points.should == 275  

	    	yielded = []
	    	@player.each_found_treasure do |treasure|
	      		yielded << treasure
	    	end 

	    	yielded.should == [Treasure.new(:hammer, 75), Treasure.new(:crowbar, 200)] 
		end

		it "should get a random boost when w00t" do
			@player.health.should == 100
			puts @player.health

			2.times { @player.w00t }

			@player.health.should == 100 + (@player.boost * 15 * 2)
		end
	end
end